Imports Microsoft.VisualBasic
Imports Telerik.WebControls

Namespace GridButtonColumnWithFilteringSortingNS
    Public Class GridButtonColumnWithFilteringSorting
        Inherits GridButtonColumn

        Public Property DataField() As String
            Get
                Dim MyRes As Object = Me.ViewState("_df")
                If (Not MyRes Is Nothing) Then
                    Return CType(MyRes, String)
                End If
                Return String.Empty
            End Get
            Set(ByVal Value As String)
                Me.ViewState("_df") = Value
            End Set
        End Property
        Public Overrides Property SortExpression() As String
            Get
                Dim MyRes As Object = Me.ViewState("_se")
                If (Not MyRes Is Nothing) Then
                    Return CType(MyRes, String)
                End If
                Return String.Empty
            End Get
            Set(ByVal Value As String)
                Me.ViewState("_se") = Value
            End Set
        End Property

        Protected Overrides Sub SetupFilterControls(ByVal cell As TableCell)
            MyBase.SetupFilterControls(cell)
            cell.Controls.RemoveAt(0)
            cell.Controls.AddAt(0, New TextBox)
        End Sub

        Public Overrides Function Clone() As GridColumn
            Return MyBase.Clone()
        End Function

        Protected Overrides Function GetFilterDataField() As String
            Return Me.DataField
        End Function

        Protected Overrides Sub SetCurrentFilterValueToControl(ByVal cell As TableCell)
            MyBase.SetCurrentFilterValueToControl(cell)

            If Not Me.CurrentFilterValue Is String.Empty Then
                CType(cell.Controls(0), TextBox).Text = Me.CurrentFilterValue
            End If
        End Sub

        Protected Overrides Function GetCurrentFilterValueFromControl(ByVal cell As TableCell) As String
            Return CType(cell.Controls(0), TextBox).Text
        End Function

        Public Overrides Function SupportsFiltering() As Boolean
            Return True
        End Function
    End Class
End Namespace
